/**
 *
 * Copyright (C) 2002-2003 VTT Information Technology. All rights reserved.
 *
 * This software is provided AS-IS with no warranty, either expressed or 
 * implied.
 *
 * This software is distributed under licence and may not be copied, modified 
 * or distributed except as expressly authorised under the terms of the licence
 * contained in the file LICENSE in this distribution.
 *
 * For more information about licensing, please refer to
 * http://opensource.erve.vtt.fi/ or contact VTT Information Technology.
 *
 */
package packetdumper;

import packetengine.*;
import packetengine.header.*;
import java.io.*;

public class PacketDumper extends NetworkInterface {
  
    /**
     * Default constructor does nothing
     */
    public PacketDumper() {
	PacketUtils.debugln(3, "PacketDumper.PacketDumper()");
    }

    // NetworkInterface methods

    public static String getIFTag() {
	PacketUtils.debugln(5, "PacketDumper.getIFTag()");
	return(TAG_IF);
    }

    public boolean setParams(String params) {
	PacketUtils.debugln(5, "PacketDumper.setParams() : params = " + params);
	return(true);
    }

    public boolean ifup() {
	PacketUtils.debugln(5, "PacketDumper.ifup()");
	return(true);
    }

    public boolean ifdown() {
	PacketUtils.debugln(5, "PacketDumper.ifdown()");

	return(true);
    }

    public boolean sendData(byte[] packet) {
	PacketUtils.debug(5, "PacketDumper.sendData() : packet = " + packet);
	if(packet != null)
	    	PacketUtils.debug(5, " packet.length = " + packet.length);
	PacketUtils.debugln(5, "");

	PacketUtils.debugln(0, "PacketDumper - Contents of the Packet:");
	PacketUtils.dumpPacket(packet);

	return(true);
    }

    public void parsePacket(byte[] packet) {
	if(IPv4.identify(packet, 0, packet.length)) {
	    PacketUtils.debugln(0, "IPv4");
	    PacketUtils.debugln(0, "\tihl\t" + IPv4.getIHL(packet, 0, packet.length));
	    PacketUtils.debugln(0, "\ttotallength\t" + IPv4.getTotalLength(packet, 0, packet.length));
	    PacketUtils.debugln(0, "\ttos\t" + IPv4.getTOS(packet, 0, packet.length));
	    PacketUtils.debugln(0, "\ttos\t" + IPv4.getTTL(packet, 0, packet.length));
	    PacketUtils.debugln(0, "\tprotocol\t" + IPv4.getProtocol(packet, 0, packet.length));
	    PacketUtils.debugln(0, "\tsource\t" + IPv4.getSourceAddress(packet, 0, packet.length));
	    PacketUtils.debugln(0, "\tdestination\t" + IPv4.getDestinationAddress(packet, 0, packet.length));
	}
    }

    // static variables

    private static final String TAG_IF = "PacketDumper";
}





