/**
 *
 * Copyright (C) 2002-2003 VTT Information Technology. All rights reserved.
 *
 * This software is provided AS-IS with no warranty, either expressed or 
 * implied.
 *
 * This software is distributed under licence and may not be copied, modified 
 * or distributed except as expressly authorised under the terms of the licence
 * contained in the file LICENSE in this distribution.
 *
 * For more information about licensing, please refer to
 * http://opensource.erve.vtt.fi/ or contact VTT Information Technology.
 *
 */
package packeteditor;

import java.util.*;
import javax.swing.*;
import packetengine.*;

/**
 *<code> ErrorMessage</code>
 *
 * @author  Titta Koskinen
 * @version 1.0
 *
 * Created on 15. heinkuuta 2002, 13:09
 */

public class ErrorMessage {

    private IPPacketEditor iPPacketEditor = null;

    /**
     * Creates a new <code>ErrorMessage</code> instance.
     *
     * @param _iPPacketEditor an <code>IPPacketEditor</code> reference.
     */
    public ErrorMessage (IPPacketEditor _iPPacketEditor) {
	iPPacketEditor = _iPPacketEditor;
    }

    /**
     * <code>printErrorMessage</code> shows error message
     * in the dialog.
     *
     * @param eMessage a <code>String</code> given message.
     */
    public void printErrorMessage (String eMessage){

	JOptionPane.showMessageDialog(iPPacketEditor.jMain, eMessage, "Error Message", JOptionPane.ERROR_MESSAGE);

    }


}

	
