/**
 *
 * Copyright (C) 2002-2003 VTT Information Technology. All rights reserved.
 *
 * This software is provided AS-IS with no warranty, either expressed or 
 * implied.
 *
 * This software is distributed under licence and may not be copied, modified 
 * or distributed except as expressly authorised under the terms of the licence
 * contained in the file LICENSE in this distribution.
 *
 * For more information about licensing, please refer to
 * http://opensource.erve.vtt.fi/ or contact VTT Information Technology.
 *
 */
package packeteditor;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.event.*;
import javax.swing.table.*;
import packetengine.*;

/**
 *<code> IPPacketEditor.java</code>
 *
 * @author  Kimmo Ahola, Titta Koskinen
 * @version 1.0
 *
 * Created on 19. keskuuta 2002, 16:26
 */

public class IPPacketEditor implements ActionListener, WindowListener {

    // Own variables 
    private Action action;
    /**
     * <code>protocols</code> vector of protocols.
     *
     */
    public Vector protocols;
    private DefaultMutableTreeNode parent, selectedTreeNode;
    private DefaultTreeModel model;
    
    /**
     * <code>jMain</code> User Interface variables.
     *
     */
    public javax.swing.JFrame jMain;
    private Container jMainContainer;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenu jMenuFile;
    private javax.swing.JMenuItem jMenuItemGet;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JMenuItem jMenuItemNew;
    private javax.swing.JMenuItem jMenuItemOpen;
    private javax.swing.JMenuItem jMenuItemSave;
    private javax.swing.JMenuItem jMenuItemSaveAs;
    private javax.swing.JSeparator jSeparator2;
    private javax.swing.JMenuItem jMenuItemQuit;
    private javax.swing.JMenu jMenuProtocol;
    private javax.swing.JMenuItem jMenuItemAddToPacket;
    private javax.swing.JMenuItem jMenuItemRemoveFromPacket;
    private javax.swing.JMenu jMenuPacket;
    private javax.swing.JMenuItem jMenuItemNewPacket;
    private javax.swing.JMenuItem jMenuItemDeletePacket;
    private javax.swing.JMenuItem jMenuItemSendPacket;
    private javax.swing.JSeparator jSeparator3;
    private javax.swing.JMenuItem jMenuItemSetSendTime;
    private javax.swing.JMenu jMenuEngine;
    private javax.swing.JMenuItem jMenuItemSetNetworkIf;
    private javax.swing.JSeparator jSeparator4;
    private javax.swing.JMenuItem jMenuItemOpenDebugWindow;
    private javax.swing.JMenuItem jMenuItemCloseDebugWindow;
    private javax.swing.JMenu jMenuSetDebugLevel;
    private javax.swing.ButtonGroup buttonGroupDebugLevel;
    private javax.swing.JRadioButtonMenuItem [] debugLevelButtonTable;
    private int iDebugLevel;
    private javax.swing.JMenu jMenuHelp;
    private javax.swing.JMenuItem jMenuItemHelp;
    private javax.swing.JMenuItem jMenuItemAbout;
    private javax.swing.JTabbedPane jTabbedPaneMaster;
    private javax.swing.JTabbedPane[] jTabbedPaneSlave;
    private javax.swing.JPanel jPanelProtocolButtons;
    private javax.swing.JButton jButtonAddToPacket;
    private javax.swing.JButton jButtonRemoveFromPacket;
    private javax.swing.JTree jTreePacketEditor;
    private javax.swing.JPanel jPanelPacketButtons;
    private javax.swing.JButton jButtonNewPacket;
    private javax.swing.JButton jButtonDeletePacket;
    private javax.swing.JButton jButtonSendPacket;
    //private javax.swing.JTable jTable1;
    private javax.swing.JPopupMenu popupSetSendTime;
    private javax.swing.JMenuItem jPopupItemSetSendTime;
    private javax.swing.JMenuItem jPopupItemDelete;

    /** Creates new form IPPacketEditor */
    public IPPacketEditor() {
    }

    // WindowListener interface functions starts
    /**
     * <code>windowActivated</code>
     * @param e a <code>WindowEvent</code> value
     */
    public void windowActivated (WindowEvent e){
    }

    /**
     * <code>windowClosed</code>
     * @param e a <code>WindowEvent</code> value
     */
    public void windowClosed (WindowEvent e){}

    /**
     * <code>windowClosing</code>
     * @param e a <code>WindowEvent</code> value
     */
    public void windowClosing (WindowEvent e){
	System.exit(0);
    }

    /**
     * <code>windowDeactivated</code>
     * @param e a <code>WindowEvent</code> value
     */
    public void windowDeactivated (WindowEvent e){}

    /**
     * <code>windowDeiconified</code>
     * @param e a <code>WindowEvent</code> value
     */
    public void windowDeiconified (WindowEvent e){}

    /**
     * <code>windowIconified</code>
     * @param e a <code>WindowEvent</code> value
     */
    public void windowIconified (WindowEvent e){}

    /**
     * <code>windowOpened</code>
     * @param e a <code>WindowEvent</code> value
     */
    public void windowOpened (WindowEvent e){}


    
   /** <code>initComponents </code> 
    * method is called from within the main to
    * initialize the form.
    */

    private void initComponents() {
	
	//New components
        jMenuBar1 = new javax.swing.JMenuBar();
        jMenuFile = new javax.swing.JMenu();
        jMenuItemGet = new javax.swing.JMenuItem();
        jSeparator1 = new javax.swing.JSeparator();
        jMenuItemNew = new javax.swing.JMenuItem();
        jMenuItemOpen = new javax.swing.JMenuItem();
        jMenuItemSave = new javax.swing.JMenuItem();
        jMenuItemSaveAs = new javax.swing.JMenuItem();
        jSeparator2 = new javax.swing.JSeparator();
        jMenuItemQuit = new javax.swing.JMenuItem();
        jMenuProtocol = new javax.swing.JMenu();
        jMenuItemAddToPacket = new javax.swing.JMenuItem();
        jMenuItemRemoveFromPacket = new javax.swing.JMenuItem();
        jMenuPacket = new javax.swing.JMenu();
	jMenuItemNewPacket = new javax.swing.JMenuItem();
	jMenuItemDeletePacket = new javax.swing.JMenuItem();
	jSeparator3 = new javax.swing.JSeparator();
	jMenuItemSendPacket = new javax.swing.JMenuItem();
        jMenuItemSetSendTime = new javax.swing.JMenuItem();
	jMenuEngine = new javax.swing.JMenu();
	jMenuItemSetNetworkIf = new javax.swing.JMenuItem();
	jSeparator4 = new javax.swing.JSeparator();
	jMenuItemOpenDebugWindow = new javax.swing.JMenuItem();
	jMenuItemCloseDebugWindow = new javax.swing.JMenuItem();
	jMenuSetDebugLevel = new javax.swing.JMenu();
	buttonGroupDebugLevel = new javax.swing.ButtonGroup();
	debugLevelButtonTable = new JRadioButtonMenuItem [6];

	/* Default value for debug level */
	iDebugLevel = 1;
	for(int i = 0; i < debugLevelButtonTable.length; i++)
	    debugLevelButtonTable[i] = new JRadioButtonMenuItem("" + i);
	debugLevelButtonTable[iDebugLevel].setSelected(true);
	action.setDebugLevel(iDebugLevel);

        jMenuHelp = new javax.swing.JMenu();
	jMenuItemHelp = new javax.swing.JMenuItem();
	jMenuItemAbout = new javax.swing.JMenuItem();
        jTabbedPaneMaster = new javax.swing.JTabbedPane();
        jTabbedPaneSlave = new javax.swing.JTabbedPane[0];
        jPanelProtocolButtons = new javax.swing.JPanel();
        jButtonAddToPacket = new javax.swing.JButton();
        jButtonRemoveFromPacket = new javax.swing.JButton();
        jTreePacketEditor = new javax.swing.JTree();
        jPanelPacketButtons = new javax.swing.JPanel();
        jButtonNewPacket = new javax.swing.JButton();
        jButtonDeletePacket = new javax.swing.JButton();
        jButtonSendPacket = new javax.swing.JButton();
        //jTable1 = new javax.swing.JTable();
	popupSetSendTime = new javax.swing.JPopupMenu();
	jPopupItemSetSendTime = new javax.swing.JMenuItem(); 
        jPopupItemDelete = new javax.swing.JMenuItem(); 

	//File menu
        jMenuFile.setText("File");
        jMenuItemGet.setText("Get...");
        jMenuItemGet.setToolTipText("Get protocol entities...");
	jMenuItemGet.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_G,InputEvent.CTRL_MASK));
        jMenuFile.add(jMenuItemGet);
        jMenuFile.add(jSeparator1);
        jMenuItemNew.setText("New");
        jMenuItemNew.setToolTipText("Create new set of packets");
	jMenuItemNew.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_N,InputEvent.CTRL_MASK));
        jMenuFile.add(jMenuItemNew);
        jMenuItemOpen.setText("Open");
        jMenuItemOpen.setToolTipText("Open set of packets");
	jMenuItemOpen.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_O,InputEvent.CTRL_MASK));
        jMenuFile.add(jMenuItemOpen);
        jMenuItemSave.setText("Save");
        jMenuItemSave.setToolTipText("Save current packet set");
	jMenuItemSave.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S,InputEvent.CTRL_MASK));
        jMenuFile.add(jMenuItemSave);
        jMenuItemSaveAs.setText("Save As...");
        jMenuItemSaveAs.setToolTipText("Save as current packet set");
	jMenuItemSaveAs.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_W,InputEvent.CTRL_MASK));
        jMenuFile.add(jMenuItemSaveAs);
        jMenuFile.add(jSeparator2);
        jMenuItemQuit.setText("Quit");
        jMenuItemQuit.setToolTipText("Quit program");
	jMenuItemQuit.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Q,InputEvent.CTRL_MASK));
	jMenuFile.add(jMenuItemQuit);
        jMenuBar1.add(jMenuFile);
        
	//Protocol menu
        jMenuProtocol.setText("Protocol");
   	jMenuItemAddToPacket.setText("Add to packet");
        jMenuProtocol.add(jMenuItemAddToPacket);
        jMenuItemRemoveFromPacket.setText("Remove from packet");
        jMenuProtocol.add(jMenuItemRemoveFromPacket);
        jMenuBar1.add(jMenuProtocol);

	//Packet menu
        jMenuPacket.setText("Packet");
        jMenuItemNewPacket.setText("New packet");
        jMenuPacket.add(jMenuItemNewPacket);
        jMenuItemDeletePacket.setText("Delete packet");
        jMenuPacket.add(jMenuItemDeletePacket);
        jMenuItemSendPacket.setText("Send packet");
        jMenuPacket.add(jMenuItemSendPacket);
	jMenuPacket.add(jSeparator3);
        jMenuItemSetSendTime.setText("Set packet's sending time");
        jMenuPacket.add(jMenuItemSetSendTime);
        jMenuBar1.add(jMenuPacket);

	//PacketEngine menu
        jMenuEngine.setText("PacketEngine");
	jMenuItemSetNetworkIf.setText ("Set network interface");
	jMenuEngine.add (jMenuItemSetNetworkIf);
	jMenuEngine.add(jSeparator4);
	jMenuItemOpenDebugWindow.setText("Open debug window");
        jMenuEngine.add(jMenuItemOpenDebugWindow);
	jMenuItemCloseDebugWindow.setText("Close debug window");
        jMenuEngine.add(jMenuItemCloseDebugWindow);
        jMenuSetDebugLevel.setText("Set debug level");
	for (iDebugLevel=0; iDebugLevel < debugLevelButtonTable.length; iDebugLevel++){
	    buttonGroupDebugLevel.add (debugLevelButtonTable[iDebugLevel]);
	    jMenuSetDebugLevel.add(debugLevelButtonTable[iDebugLevel]);
	}
        jMenuEngine.add(jMenuSetDebugLevel);
        jMenuBar1.add(jMenuEngine);	

	//Help menu
        jMenuHelp.setText("Help");
        jMenuBar1.add(jMenuHelp);
	jMenuItemHelp.setText("Help");
        jMenuHelp.add(jMenuItemHelp);
	jMenuItemAbout.setText("About...");
        jMenuHelp.add(jMenuItemAbout);

	//PopupMenu
 	jPopupItemSetSendTime.setText ("Set sending time");
 	jPopupItemDelete.setText ("Delete");
 	popupSetSendTime.add (jPopupItemSetSendTime);
 	popupSetSendTime.add (jPopupItemDelete);
      	jTreePacketEditor.add(popupSetSendTime);
 	jTreePacketEditor.addMouseListener(new PopupTrigger());

        //Tabbedpanel and buttonpanel layouts
        jMainContainer.setLayout(new AbsoluteLayout());
	jPanelProtocolButtons.setLayout(new AbsoluteLayout());
	jPanelProtocolButtons.setBorder(new javax.swing.border.EtchedBorder(javax.swing.border.EtchedBorder.RAISED, java.awt.Color.lightGray, java.awt.Color.gray));
        
	//Buttons
	jButtonAddToPacket.setText("Add to packet");
        jPanelProtocolButtons.add(jButtonAddToPacket, new AbsoluteConstraints(140, 10, -1, -1));
	jButtonRemoveFromPacket.setText("Remove from packet");
        jPanelProtocolButtons.add(jButtonRemoveFromPacket, new AbsoluteConstraints(390, 10, -1, -1));
	jMainContainer.add(jPanelProtocolButtons, new AbsoluteConstraints(-10, 310, 680, 40));
        jPanelPacketButtons.setLayout(new AbsoluteLayout());
        jButtonNewPacket.setText("New packet");
        jPanelPacketButtons.add(jButtonNewPacket, new AbsoluteConstraints(10, 10, -1, -1));
        jButtonDeletePacket.setText("Delete packet");
        jPanelPacketButtons.add(jButtonDeletePacket, new AbsoluteConstraints(160, 10, -1, -1));
        jButtonSendPacket.setText("Send packet(s)");
        jPanelPacketButtons.add(jButtonSendPacket, new AbsoluteConstraints(520, 10, -1, -1));
	jMainContainer.add(jPanelPacketButtons, new AbsoluteConstraints(0, 640, 670, 40));
        
	// TabbedPane
	jTabbedPaneMaster.setTabLayoutPolicy(JTabbedPane.SCROLL_TAB_LAYOUT);
	for(int i=0; i<jTabbedPaneSlave.length; i++)
	    jTabbedPaneSlave[i].setTabLayoutPolicy(JTabbedPane.SCROLL_TAB_LAYOUT);
 	jMainContainer.add(jTabbedPaneMaster, new AbsoluteConstraints(0, 10, 680, 300));
        
	// Menubar
        jMain.setJMenuBar(jMenuBar1);

	// Tree
	DefaultMutableTreeNode top = new DefaultMutableTreeNode(new OidNode(1, "PacketSet", null));
	parent = top;
        DefaultMutableTreeNode node = new DefaultMutableTreeNode(new OidNode(1, "Packet_1", "1", null ) );
        parent.add(node);
	model = new DefaultTreeModel(top);
	jTreePacketEditor.setModel(model);

	//Scrollabl
 	JScrollPane scroll = new JScrollPane(jTreePacketEditor);
 	scroll.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
 	scroll.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
 	jMainContainer.add(scroll, new AbsoluteConstraints(0, 353, 670, 280));

	setActionListeners();

        jMain.pack();
    }



   /** <code> setActionListeners </code>
    *  method is called within the initComponents
    *  to add actionListeners to the components.
    */
    private void setActionListeners() 
    {
	jMenuItemGet.addActionListener(this);
	jMenuItemNew.addActionListener(this);
	jMenuItemOpen.addActionListener(this);
	jMenuItemSave.addActionListener(this);
	jMenuItemSaveAs.addActionListener(this);
	jMenuItemQuit.addActionListener(this);
	jMenuItemAddToPacket.addActionListener(this);
        jMenuItemRemoveFromPacket.addActionListener(this);
	jMenuItemNewPacket.addActionListener(this);
	jMenuItemDeletePacket.addActionListener(this);
	jMenuItemSendPacket.addActionListener(this);
        jMenuItemSetSendTime.addActionListener(this);
	jMenuItemSetNetworkIf.addActionListener(this);
	jMenuItemOpenDebugWindow.addActionListener (this);
	jMenuItemCloseDebugWindow.addActionListener (this);
	for (iDebugLevel=0; iDebugLevel < debugLevelButtonTable.length; iDebugLevel++){
	    debugLevelButtonTable[iDebugLevel].addActionListener (this);
	}
	jMenuItemHelp.addActionListener (this);
	jMenuItemAbout.addActionListener (this);
        jButtonAddToPacket.addActionListener(this); 
        jButtonRemoveFromPacket.addActionListener(this); 
        jButtonNewPacket.addActionListener(this); 
        jButtonDeletePacket.addActionListener(this); 
        jButtonSendPacket.addActionListener(this);
	jPopupItemDelete.addActionListener (this);
	jPopupItemSetSendTime.addActionListener (this);


	jTreePacketEditor.addTreeSelectionListener(new EditorTreeSelectionListener());
    }

    /**
     * <code> actionPerformed </code> 
     * method is called when "some action" is 
     * perfomed in the form.
     *
     * @param evt an <code>ActionEvent</code> which indicates that 
     * the action occurred in the user interface.
     *
     */
    public void actionPerformed (ActionEvent evt) 
    {
	Object source = evt.getSource();

	if(source instanceof JRadioButtonMenuItem) 
	{
	    for (int i = 0; i < debugLevelButtonTable.length; i++){
		if (debugLevelButtonTable[i].isSelected()){
		    action.setDebugLevel(i);
		    break;
		}
	    }
	}
	else if(source instanceof JMenuItem) 
	{	    
	    if (source == jMenuItemGet) {

		if (protocols != null){
		    for(int i=0; i<jTabbedPaneSlave.length; i++)
			jTabbedPaneSlave[i].removeAll();
		    jTabbedPaneMaster.removeAll();
		    protocols = null;
		}

		protocols = action.getProtocolEntities("");
		if (protocols != null){
		    jTabbedPaneSlave = new JTabbedPane[0];
		    JTabbedPane slave = null;

		    // Insert new tab to the tabbedpane
		    for (Enumeration e = protocols.elements(); e.hasMoreElements();) {
			Object o = e.nextElement();

			if(o instanceof String) {
			    // Finalize previous slave tabbedpane
			    if(slave != null) {
				slave.setSelectedIndex(0);		
				slave.revalidate();
				slave.repaint();
			    }

			    // Create new slave tabbedpane 
			    slave = new javax.swing.JTabbedPane();
			    
			    // Copy old slaves and append new slave to slavetabbedpane array 
			    JTabbedPane[] tmpSlave = new JTabbedPane[jTabbedPaneSlave.length+1];
			    for(int i=0; i<jTabbedPaneSlave.length; i++)
				tmpSlave[i] = jTabbedPaneSlave[i];
			    tmpSlave[jTabbedPaneSlave.length] = slave;
			    jTabbedPaneSlave = tmpSlave;
			    
			    // Attach slave to master tabbedpane
			    jTabbedPaneMaster.addTab((String) o, slave);
			}
			else if(o instanceof Protocol) {
			    Protocol proto = (Protocol) o; 
			    ParameterTableModel myModel = new ParameterTableModel(proto);
			    JTable table = new JTable(myModel);
			    slave.addTab(proto.getTag(), table);
			}
		    }
		
		    // Finalize last slave tabbedpane 
		    if(slave != null) {
			slave.setSelectedIndex(0);		
			slave.revalidate();
			slave.repaint();
		    }

		    jTabbedPaneMaster.setSelectedIndex(0);		
		    jTabbedPaneMaster.revalidate();
		    jTabbedPaneMaster.repaint();
		}
		else
		    action.errorMessage.printErrorMessage("Protocols could not be found");
	    }
	    else if (source == jMenuItemNew) {
		action.newPacketSet();
	    }
	    else if (source == jMenuItemOpen){
		action.openPacketSet();
	    }
	    else if (source == jMenuItemSave) {
		action.savePacketSet();
	    }
	    else if (source == jMenuItemSaveAs) {
		action.savePacketSetAs();
	    }
	    else if (source == jMenuItemQuit) {
		System.exit(0);
	    }
	    else if (source == jMenuItemAddToPacket) {
		action.addToPacket();
	    }
	    else if (source == jMenuItemRemoveFromPacket) {
		action.removeFromPacket();
	    }
	    else if (source == jMenuItemNewPacket) {
		action.newPacket();
	    }
	    else if (source == jMenuItemDeletePacket) {
		action.deletePacket();
	    }
	    else if (source == jMenuItemSendPacket) {
		action.sendPacket();
	    }
	    else if (source == jMenuItemSetSendTime) {
		boolean bCorrectParent = false;
		MutableTreeNode node = getSelectedTreeNode();
		if (node != null){
		    MutableTreeNode parent = (MutableTreeNode) node.getParent();
		    // Node has at least one parent
		    if (parent != null) {
			MutableTreeNode newParent = (MutableTreeNode) parent.getParent();
			if ( newParent == null )
			    bCorrectParent = true;
		    }
		    if ( bCorrectParent && parent != null ){
			action.setSendTime();
		    }
		}		
	    }
	    else if (source == jMenuItemSetNetworkIf) {
		action.setNetworkIf();
	    }
	    else if (source == jMenuItemOpenDebugWindow) {
		action.openDebugWindow();
	    }
	    else if (source == jMenuItemCloseDebugWindow) {
		action.closeDebugWindow();
	    }
	    else if (source == jMenuItemHelp) {
		action.help();
	    }
	    else if (source == jMenuItemAbout) {
		action.about();
	    }
	    else if (source == jPopupItemSetSendTime) {
		action.setSendTime();
	    }
	    else if (source == jPopupItemDelete) {
		action.deletePacket();
	    }

	}

	else if (source instanceof JButton)
	{
	    if (source == jButtonAddToPacket){		
		action.addToPacket();
	    }
	    else if(source == jButtonRemoveFromPacket){
		action.removeFromPacket();
	    }
	    else if(source == jButtonNewPacket){
		action.newPacket();
	    }
	    else if(source == jButtonDeletePacket){
		action.deletePacket();
	    }
	    else if(source == jButtonSendPacket){
		action.sendPacket();
	    }
	}

	jMainContainer.repaint();
	jTreePacketEditor.updateUI();
    }
 
    /**
     * <code>getTabbedPane</code>
     *
     * @return a <code>JTabbedPane</code> refence.
     */
    public JTabbedPane getTabbedPaneMaster() {
	return jTabbedPaneMaster;
    }

    /**
     * <code>getTabbedPaneSlave</code>
     *
     * @return a <code>JTabbedPane[]</code>
     */
    public JTabbedPane[] getTabbedPaneSlave() {
	return jTabbedPaneSlave;
    }

    /**
     * <code>getTree</code>
     *
     * @return a <code>JTree</code> reference.
     */
    public JTree getTree() {
	return jTreePacketEditor;
    }

    /**
     * <code>getTreeParent</code>
     *
     * @return a <code>DefaultMutableTreeNode</code> value for tree's root node.
     */
    public DefaultMutableTreeNode getTreeParent() {
	return parent;
    }

    /**
     * <code>setTreeParent</code> sets given node for tree's root.
     *
     * @param _parent a <code>DefaultMutableTreeNode</code> value
     * 
     */
    public void setTreeParent(DefaultMutableTreeNode _parent) {
	parent = _parent;
    }

    /**
     * <code>getSelectedTreeNode</code>
     *
     * @return a <code>DefaultMutableTreeNode</code> value as selected tree node.
     */
    public DefaultMutableTreeNode getSelectedTreeNode() {
	return selectedTreeNode;
    }

    /**
     * <code>main</code> 
     * creates Action class, adds window listeners
     * and shows created frame.
     *
     */
    public void main() {

	action = new Action(this);
	protocols = null;

	//Create new frame and set location
        jMain = new JFrame ("Nipper");
 	Toolkit t = Toolkit.getDefaultToolkit();
 	Dimension d = t.getScreenSize();
 	int screenHeight = d.height;
 	int screenWidth = d.width;
 	jMain.setLocation (screenWidth / 4, screenHeight / 4);
	jMainContainer = jMain.getContentPane();
 	initComponents();

	// Now this is easy, ain't it ?
	actionPerformed(new ActionEvent(jMenuItemGet, 0, "Automatic Initilisation"));

	// Add WindowListener to this frame and show the frame
	jMain.addWindowListener(this);
        jMain.show();
	

    }

/**
 * <code>EditorTreeSelectionListener</code> class implements
 *  selection listener to the tree.
 * 
 */
class EditorTreeSelectionListener implements TreeSelectionListener {

    /**
     * <code>getTreeNode</code>
     *
     * @param _path a <code>TreePath</code> value
     * @return a <code>DefaultMutableTreeNode</code> value as selected tree node.
     *
     */
    DefaultMutableTreeNode getTreeNode(TreePath path) {
	return (DefaultMutableTreeNode) (path.getLastPathComponent());
    }


    /**
     * <code>valueChanged</code> called whenever the value of the selection changes.
     *
     * @param event a <code>TreeSelectionEvent</code> value that characterizes the change.
     * 
     */
    public void valueChanged(TreeSelectionEvent event) {
	DefaultMutableTreeNode node = getTreeNode(event.getPath());
	OidNode selectedOidNode = (OidNode) node.getUserObject();
	selectedTreeNode = (DefaultMutableTreeNode) node;

	int iTabCountMaster = jTabbedPaneMaster.getTabCount();
	if (iTabCountMaster > 0){
	    // Is selected Packet_?
	    if ( selectedOidNode.getProtocol() == null ) {
		int masterIndex = jTabbedPaneMaster.getSelectedIndex();
		int slaveIndex = jTabbedPaneSlave[masterIndex].getSelectedIndex();
		String name = jTabbedPaneSlave[masterIndex].getTitleAt(slaveIndex);
		
		for (Enumeration e = protocols.elements(); e.hasMoreElements();) {
		    Protocol proto = null;
		    do {
			Object o = e.nextElement();
			if(o instanceof Protocol) {
			    proto = (Protocol) o;
			    break;
			}
		    } while(e.hasMoreElements());
		    
		    if (proto != null && proto.getName().equals(name)) {
			ParameterTableModel myModel = new ParameterTableModel(proto);
			JTable table = new JTable(myModel);

			jTabbedPaneSlave[masterIndex].setComponentAt(slaveIndex, table);
			jTabbedPaneSlave[masterIndex].setSelectedIndex(slaveIndex);
			jTabbedPaneSlave[masterIndex].revalidate();
			jTabbedPaneSlave[masterIndex].repaint();

			jTabbedPaneMaster.setSelectedIndex(masterIndex);
			jTabbedPaneMaster.revalidate();
			jTabbedPaneMaster.repaint();

			break;
		    }
		}//for
		
	    } // if ( selectedOidNode ...)
	    else {
		int iTabbedPanesMaster = jTabbedPaneMaster.getTabCount();
		for (int j=0; j < iTabbedPanesMaster; j++) {
		    int iTabbedPanesSlave = jTabbedPaneSlave[j].getTabCount();
		    for (int i=0; i < iTabbedPanesSlave; i++) {
			if ( jTabbedPaneSlave[j].getTitleAt(i).equals(selectedOidNode.toName()) ) {
			    ParameterTableModel myModel = new ParameterTableModel(selectedOidNode.getProtocol());
			    JTable table = new JTable(myModel);

			    jTabbedPaneSlave[j].setComponentAt(i, table);
			    jTabbedPaneSlave[j].setSelectedIndex(i);
			    jTabbedPaneSlave[j].revalidate();
			    jTabbedPaneSlave[j].repaint();

			    jTabbedPaneMaster.setSelectedIndex(j);
			    jTabbedPaneMaster.revalidate();
			    jTabbedPaneMaster.repaint();

			    break;
			}//if (jTabbedPaneSlave[j]		
		    } // for
		}//for
	    } // else
	}   //if iTabCount 
     }    // public void valueChanged
  }     // class EditorTreeSelectionListener


/**
 * <code>PopupTrigger</code> class implements
 *  Mouse event listener to the tree. When packet is selected,
 *  popup menu is shown.
 *
 *  Popup menus are triggered differently on different systems. 
 *  Therefore, isPopupTrigger  should be checked in both mousePressed 
 *  and mouseReleased  for proper cross-platform functionality. 
 * 
 */
class PopupTrigger extends MouseAdapter {

    /**
     * <code>mouseReleased</code> invoked when a mouse 
     * button has been released on a tree.
     *
     * @param e a <code>MouseEvent</code>, an event which indicates that 
     * a mouse action occurred in a tree.
     */
    public void mouseReleased(MouseEvent e) {
	
	boolean bCorrectParent = false;
	MutableTreeNode node = getSelectedTreeNode();
        if (node != null){
            MutableTreeNode parent = (MutableTreeNode) node.getParent();
            // Node has at least one parent eg. is not root
            if (parent != null) {
                MutableTreeNode newParent = (MutableTreeNode) parent.getParent();
                if ( newParent == null )
                    bCorrectParent = true;
            }
            if ( bCorrectParent && parent != null ){
		int iButton = e.getButton();
		if ( e.isPopupTrigger() && iButton == MouseEvent.BUTTON3) {
		    int x = e.getX();
		    int y = e.getY();
		    TreePath path = jTreePacketEditor.getPathForLocation(x,y);
		    if (path != null) {
			popupSetSendTime.show(jTreePacketEditor, x, y);
		    }
		}
	    }
	}
    }

    /**
     * <code>mousePressed</code> invoked when a mouse 
     * button has been pressed on a tree.
     *
     * @param e a <code>MouseEvent</code> an event which indicates that 
     * a mouse action occurred in a tree. 
     */
    public void mousePressed(MouseEvent e) {

	boolean bCorrectParent = false;
	MutableTreeNode node = getSelectedTreeNode();
        if (node != null){
            MutableTreeNode parent = (MutableTreeNode) node.getParent();
            // Node has at least one parent eg. is not root
            if (parent != null) {
                MutableTreeNode newParent = (MutableTreeNode) parent.getParent();
                if ( newParent == null )
                    bCorrectParent = true;
            }
            if ( bCorrectParent && parent != null ){
		int iButton = e.getButton();
		if (e.isPopupTrigger()&& iButton == MouseEvent.BUTTON3) {
		    int x = e.getX();
		    int y = e.getY();
		    TreePath path = jTreePacketEditor.getPathForLocation(x,y);
		    if (path != null) {
			popupSetSendTime.show(jTreePacketEditor, x, y);
		    }
		}
	    }
	}
    }
} //Class PopupTrigger

} // Class IPPacketEditor


/**
 *  <code>OidNode</code> class encapsulates a single
 *  object identifier as a number and a String name 
 *  describing the associated object. All values are
 *  passed to act as a node's user object.
 * 
 */
class OidNode {

    protected int id;
    protected String name;
    protected Protocol proto;
    protected String stime = null;

    /**
     * Creates a new <code>OidNode</code> instance.
     *
     * @param _id a <code>int</code> value
     * @param _name a <code>String</code> value
     * @param _proto a <code>Protocol</code> entity
     */
    public OidNode(int _id, String _name, Protocol _proto)
    {
	id = _id;
	name = _name;
	proto = _proto;
    }

    /**
     * Creates a new <code>OidNode</code> instance.
     *
     * @param _id a <code>int</code> value
     * @param _name a <code>String</code> value
     * @param _proto a <code>Protocol</code> entity 
     */
    public OidNode(int _id, String _name, String _stime, Protocol _proto)
    {
	id = _id;
	name = _name;
	proto = _proto;
	stime = _stime;
    }

    /**
     * <code>getId</code>
     *
     * @return a <code>int</code> id of the node.
     */
    public int getId() { return id; }

    /**
     * <code>toName</code>
     *
     * @return a <code>String</code> name and possible 
     * sending time of the packet node.
     */
    public String toName() {
	if (stime != null)
	    return (name + " stime: " + stime); 
	else 
	    return name;
    }

    /**
     * <code>toString</code>
     *
     * @return a <code>String</code>name and possible 
     * sending time of the packet node.
     */
    public String toString() { 
	if (stime != null)
	    return (name + " stime: " + stime); 
	else
	    return name;
    }

    /**
     * <code>getProtocol</code>
     *
     * @return a <code>Protocol</code> reference
     */
    public Protocol getProtocol() { return proto; }

    /**
     * <code>getSendTime</code>
     *
     * @return a <code>String</code> sending time of the packet.
     */
    public String getSendTime() { return stime; }

    /**
     * <code>setSendTime</code> sets given value for 
     * packet's new sending time.
     *
     * @param _stime a <code>String</code> sending time.
     */
    public void setSendTime(String _stime) {
	stime = _stime;
    }
}

/** <code> ParameterTableModel </code>
 *  class implements table shown in
 *  every tabbedpane's tab. Table includes
 *  tag, parameter name and user given value
 *  of protocol header. All protocol headers
 *  are shown is separate tables eg. tabs.
 */
class ParameterTableModel extends AbstractTableModel {

    private boolean DEBUG = true;
    final String[] columnNames = {"Tag",
				  "Parameter", 
				  "Value"};
    Vector vParameters = null;
    Protocol protocol = null;

    /**
     * Creates a new <code>ParameterTableMode</code> instance.
     *
     * @param _protocol a <code>Protocol</code> entity
     */
    public ParameterTableModel(Protocol _protocol) {
	protocol = _protocol;
	vParameters = protocol.getParameters();
    }

    /**
     * <code>setData</code> sets given parametrs
     * to the parameter vector
     *
     * @param _parameters a <code>Vector</code> protocol's parameters 
     */
    public void setData(Vector _parameters) {
	vParameters = _parameters;
    }

    /**
     * <code>getData</code> returns protocol's parameters.
     *
     * @return a <code>Vector</code> protocol's parameters.
     */
    public Vector getData() {
	return vParameters;
    }

    /**
     * <code>getProtocol</code> return reference to the protocol entity.
     *
     * @return a <code>Protocol</code> reference to protocol.
     */
    public Protocol getProtocol() {
	return protocol;
    }

    /**
     * <code>getColumnCount</code>
     *
     * @return a <code>int</code> number of columns in the table.
     */
    public int getColumnCount() {
	return columnNames.length;
    }

    /**
     * <code>getRowCount</code>
     *
     * @return a <code>int</code> number of rows in the table.
     */        
    public int getRowCount() {
	if (vParameters == null)
	    return 0;

	return vParameters.size();
    }

    /**
     * <code>getColumnName</code> return column name.
     *
     * @param row a <code>int</code> the number of row
     * @return a <code>String</code> column's name
     */    
    public String getColumnName(int col) {
	return columnNames[col];
    }

    /**
     * <code>getValueAt</code>
     *
     * @param row a <code>int</code> the number of row from get a value.
     * @param col a <code>int</code> the number of column from get a value.
     * @return a <code>Object</code> including the value of the
     * requested position.
     */    
    public Object getValueAt(int row, int col) {
	int i=0;
	Parameter parameter  = null;


	if (vParameters == null)
	    return (Object) new String();

	Enumeration e = vParameters.elements();
        parameter = (Parameter) e.nextElement();

	for (; e.hasMoreElements() && i != row; i++) {
	    parameter = (Parameter) e.nextElement();
	}
	
	if (i == row && parameter != null ) {
	    if (col == 0)
		return (Object)parameter.getTag();
	    else if (col == 1)
		return (Object)parameter.getName();
	    else
		return (Object)parameter.getValue();
	}
	return (Object) new String();
    }
    /**
     * <code>getColumnClass</code> JTable uses this method to determine the default renderer/
     * editor for each cell.  If we didn't implement this method,
     * then the last column would contain text ("true"/"false"),
     * rather than a check box.
     *
     * @param c a <code>int</code> identifies the column in the view being queried.
     * @return a <code>Class</code> the type of the column at position column in the 
     * view where the first column is column 0.
     *    
     */
    public Class getColumnClass(int c) {
	return getValueAt(0, c).getClass();
    }

    /**
     * <code>isCellEditable</code> checks is selected cell editable.
     * (only third colum that includes value can be edited)
     *
     * @return a <code>boolean</code> indicating if cell is editable.
     *
     */    
    public boolean isCellEditable(int row, int col) {
	if (col < 2) { 
	    return false;
	} else {
	    return true;
	}
    }

    /**
     * <code>setValueAt</code> set's given value to the table. 
     *
     * @param value a <code>Object</code> value to the table.
     * @param row a <code>int</code> the number of row to set a given value.
     * @param col a <code>int</code> the number of column to set a given value.
     *
     */
    public void setValueAt(Object value, int row, int col) {
	Parameter parameter = null;
	int i=0;
	Enumeration e = vParameters.elements();
        parameter = (Parameter) e.nextElement();

	for (; e.hasMoreElements() && i != row; i++) {
	    parameter = (Parameter) e.nextElement();
	}

	if (i == row && parameter != null ) {
	    if (col == 2)
		parameter.setValue(new String(value.toString()));
	}

	e = vParameters.elements();
        parameter = (Parameter) e.nextElement();
	
	for (; e.hasMoreElements() && i != row; i++) {
	    parameter = (Parameter) e.nextElement();
	}

    }
}

