/**
 *
 * Copyright (C) 2002-2003 VTT Information Technology. All rights reserved.
 *
 * This software is provided AS-IS with no warranty, either expressed or 
 * implied.
 *
 * This software is distributed under licence and may not be copied, modified 
 * or distributed except as expressly authorised under the terms of the licence
 * contained in the file LICENSE in this distribution.
 *
 * For more information about licensing, please refer to
 * http://opensource.erve.vtt.fi/ or contact VTT Information Technology.
 *
 */
package packetengine.header;

import packetengine.*;
import java.util.*;
import java.net.*;
import javax.xml.parsers.*;
import org.xml.sax.*;
import org.xml.sax.helpers.*;


public class IPv4_OPT_EOL extends Header implements IPv4Option {

    public IPv4_OPT_EOL() {
	super();

        buffer = new byte[1];
        start = 0;
        end = 1;
    }

    /* Header methods */

    public static String getName() {
        return(NAME_NAME);
    }

    public static String getType() {
        return(TAG_NAME);
    }

    public String getHeaderType() {
        return(TAG_NAME);
    }

	public byte getProtocolID() {
		return(PROTOCOL_ID);
	}


    public int build(byte[] buffer, int offset, int length, LinkedList headerList, int index) {
	buffer[start] = 0;
	return(0);
    }

    /* DefaultHandler methods */

    public void characters(char[] ch, int offset, int length) throws SAXException {

    }

    /* IPv4_OPT_EOL methods */

    /* private IPv4_OPT_EOL methods */


    /* name */
    private static final String TAG_NAME = "IPv4_OPT_EOL";
    private static final String NAME_NAME = "IPv4 Option End of List (EOL)";

    /* tags */

    /* protocol id */
    public static final byte PROTOCOL_ID = Header.UNDEFINED_PROTOCOL;
}
