/**
 *
 * Copyright (C) 2002-2003 VTT Information Technology. All rights reserved.
 *
 * This software is provided AS-IS with no warranty, either expressed or 
 * implied.
 *
 * This software is distributed under licence and may not be copied, modified 
 * or distributed except as expressly authorised under the terms of the licence
 * contained in the file LICENSE in this distribution.
 *
 * For more information about licensing, please refer to
 * http://opensource.erve.vtt.fi/ or contact VTT Information Technology.
 *
 */
package packetengine.header;

import packetengine.*;
import java.util.*;
import java.net.*;
import javax.xml.parsers.*;
import org.xml.sax.*;
import org.xml.sax.helpers.*;


public class IPv6_OPT_SUB_BINDING_UNIQUE_ID extends Header implements IPv6SubOption {

    public IPv6_OPT_SUB_BINDING_UNIQUE_ID() {
	super();

        buffer = new byte[4];
        start = 0;
        end = 4;
    }

    /* Header methods */

    public String getHeaderType() {
	return(TAG_NAME);
    }

	public byte getProtocolID() {
		return(PROTOCOL_ID);
	}


    public static String getName() {
        return(NAME_NAME);
    }

    public static String getType() {
        return(TAG_NAME);
    }

    public static LinkedHashMap getTags() {
        LinkedHashMap h = new LinkedHashMap();
	h.put(TAG_ID, NAME_ID);
        return(h);
    }

    public int build(byte[] buffer, int offset, int length, LinkedList headerList, int index) {
	buffer[start] = (byte) 2;
	buffer[start+1] = (byte) 2;
	return(0);
    }

    /* DefaultHandler methods */

    public void characters(char[] ch, int offset, int length) throws SAXException {
	if(TAG_ID.equals(tag)) {
            PacketUtils.debugln(5, TAG_ID + ": " + new String(ch, offset, length));
	    setID(PacketUtils.parseInt(new String(ch, offset, length)));
        }
    }

    /* IPv6_OPT_SUB_BINDING_UNIQUE_ID methods */

    public void setID(int id) {
	buffer[start+2] = (byte) ((id & 0xff00) >>> 8);
	buffer[start+3] = (byte) ((id & 0x00ff));
    }

    /* private IPv6_OPT_SUB_BINDING_UNIQUE_ID methods */

    /* name */
    private static final String TAG_NAME = "IPv6_OPT_SUB_BINDING_UNIQUE_ID";
    private static final String NAME_NAME = "IPv6 Binding Update Sub Option Unique Identifier";

    /* tags */
    private static final String TAG_ID = "id";
    private static final String NAME_ID = "Identifier";

    /* protocol id */
    public static final byte PROTOCOL_ID = Header.UNDEFINED_PROTOCOL;
}

