/**
 *
 * Copyright (C) 2002-2003 VTT Information Technology. All rights reserved.
 *
 * This software is provided AS-IS with no warranty, either expressed or 
 * implied.
 *
 * This software is distributed under licence and may not be copied, modified 
 * or distributed except as expressly authorised under the terms of the licence
 * contained in the file LICENSE in this distribution.
 *
 * For more information about licensing, please refer to
 * http://opensource.erve.vtt.fi/ or contact VTT Information Technology.
 *
 */
package packetengine.header;

public abstract class TLVHeader extends Header {

    /* public variables */
    // none

    /* private variables */
    // none
    
    /* protected variables */
    protected int value_length;
    protected boolean FLAG_TYPE = false;
    protected boolean FLAG_LEN = false;

    /* constructor */
    public TLVHeader() {
	super();

	value_length = 0;
	FLAG_TYPE = false;
	FLAG_LEN = false;
    }

    /* public methods */
    //none

    /* protected methods */

    protected void setTypeByte(byte type) {
	buffer[start] = (byte) (type & 0xff);
    }

    protected void setLengthByte(byte len) {
	buffer[start+1] = (byte) (len & 0xff);
    }

    protected void setValue(byte[] value) {
	if(value == null)
	    value_length = 0;
	else {
	    if(buffer == null || value.length > buffer.length-start-2)
		return;
	
	    System.arraycopy(value, 0, buffer, start+2, value.length);

	    value_length = value.length;
	}
	if(!FLAG_LEN)
	    setLengthByte((byte) (value_length & 0xff));
    }

    protected static byte getTypeByte(byte[] data, int offset, int length) {
	return(data[offset]);
    }

    protected static byte getLengthByte(byte[] data, int offset, int length) {
	return(data[offset+1]);
    }

    protected static byte[] getValue(byte[] data, int offset, int length) {
	if(data == null)
	    return(null);

	int len = (int) (getLengthByte(data, offset, length) & 0xff);
	if(len > data.length-offset-2)
	    len = data.length-offset-2;
	byte[] value = new byte[len];

	System.arraycopy(data, offset+2, value, 0, value.length);

	return(value);
    }

    /* private methods */
    //none

    /* static private variables */
    //none

    /* static public variables */
    //none
}
